/////Begin Global Variables//////

n=1; //This is the iteration number of the cube. n=0 is a solid cube.

Cube_size=30; //This is the size of the cube.

C=.3; //This is a constant.

/////End Global Variables//////


////This is the code for the singular cube.///////


//This module calls the physical cube.

module Sierpinski_cube(){

	difference(){

		cube(Cube_size,center=true);

		Sierpinski_iteration();
		rotate([0,90,0])
		Sierpinski_iteration();
		rotate([90,0,0])
		Sierpinski_iteration();
		
		
		}
	}

Sierpinski_cube();

//This is the code that dictates the fractal code.

module Sierpinski_iteration(){

for(k=[0:n]){

			for(i=[-(pow(3,(k-1))-1)/2:(pow(3,(k-1))-1)/2],j=[-(pow(3,(k-1))-1)/2:(pow(3,(k-1))-1)/2])

			translate([Cube_size/pow(3,(k-1))*i,Cube_size/pow(3,(k-1))*j,0])

			for(i=[-1:1])
			translate([0,0,Cube_size/3*i])

			cube([Cube_size/(pow(3,(k))),Cube_size/(pow(3,(k))),Cube_size/3+C], center=true);
	}
}
